<?php
namespace Claromentis\Core\Acl;

$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"] = (@$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"] ?: array()) + array("_13753452fadd" . "c2d6579d9ba29" . "1d77955" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9iamVjd" . "CBJRCBub3Qgc3BlY2lmaWVk"), "_c726d9545" . "0d9d503c7e" . "f86671a4fc" . "991" => base64_decode("Q2FuJ3QgZGVsZXRlIHBlcm1pc3Np" . "b25zIGZyb20gZGF0YWJhc2U6IG9i" . "amVjdCBJRCBub3Qgc3BlY2lmaWVk"), "_3b772c19f5d5e7c8d750" . "ae0a815c7ed7" => base64_decode("Q2FuJ3QgZGVsZXRlIHBlcm1pc3Npb25zIGZyb20gZGF0Y" . "WJhc2U6IG9iamVjdCBjbGFzcyBub3Qgc3BlY2lmaWVk"), "_966b46f1eeef931d3aab02109" . "117071b" => base64_decode("Q2FuJ3Qgc2F2ZSBwZXJtaXNzaW9uczogb2JqZWN0IGNsYXN" . "zIG5vdCBzcGVjaWZpZWQ="), "_58d506edba9ce" . "80af6a061b73e2" . "eb66c" => base64_decode("X" . "w" . "=" . "="), "_b794b4b6e96b498c4b34" . "de980e60c7c7" => base64_decode("U0VMRUNUIHBlcm1fb3duZXJfY2xhc3NfaWQsIHBlcm1fb3duZXJfaWQsIHJpZ2h0cyBGUk9NIHBlcm1pc3Npb25zIFd" . "IRVJFIG9iamVjdF9pZD1pbnQ6aWQgQU5EIGNsYXNzX2lkPWludDpjbGFzc19pZA=="), "_0d42dc2ab069f31f94b" . "667ad83e04b04" => base64_decode("IFZBTFVFUyAoaW50OmNsYXNzX2lkLCBpbnQ6a" . "WQsIGludDpvY2xhc3MsIGludDpvaWQsIGludD" . "pwZXJtcyk="), "_f4ebcb18d663" . "5cf0340b0776a" . "a6c2368" => base64_decode("YWN" . "sOg" . "=="), "_f3a6782a0639ec7ac" . "8ea0a44e06d50fa" => base64_decode("REVMRVRFIEZST00gcGVybWlzc2lv" . "bnMgV0hFUkUgY2xhc3NfaWQ9aW50" . "OmNsYXNzX2lkIEFORCBvYmplY3Rf" . "aWQ9aW50Omlk"), "_190a27304b863980e" . "14c5514d55f6770" => base64_decode("SGFzUGVybWlzc" . "2lvbnM="), "_3f0a984c475ce692d87e01ddab" . "f63065" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6I" . "G9iamVjdCBJRCBub3Qgc3" . "BlY2lmaWVk"), "_5ca1c8340633c3313f886f2a4d" . "ccb7e8" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9iamVjdCBjbGFzcyBub3Qgc3B" . "lY2lmaWVk"), "_c75934a16a05f05" . "c14432ff269640ec" . "4" => base64_decode("SU5TRVJUIElOVE8gcGVybWlzc2lvbnMgKGNsYXNzX2lkLCBvYmplY3RfaWQsIHBlcm1fb3" . "duZXJfY2xhc3NfaWQsIHBlcm1fb3duZXJfaWQsIHJpZ2h0cyk="));
use Claromentis\Core\Acl\Exception\InvalidSubjectException;
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;
use Claromentis\Core\Security\SecurityContext;
use Claromentis\Core\Services;





class AclRepository
{
    private $db;
    private $cache;
    public function __construct(DAL\Db $db, \ClaCacheHandler $_c38eecfdb2f424d044d37360b72af861)
    {
        $this->db = $db;
        $this->cache = $_c38eecfdb2f424d044d37360b72af861;
    }
    
    
    
    
    public static function I()
    {
        return Services::I()->acl;
    }
    
    
    
    
    
    
    
    
    public function Get(int $_f48acc58bf4e08e63b1173fb1800d0f6, int $object_id)
    {
        $acl = new Acl($_f48acc58bf4e08e63b1173fb1800d0f6, $object_id);
        if ($object_id > 0) {
            $this->Load($acl);
        }
        return $acl;
    }
    
    
    
    
    
    
    
    
    public function Load(Acl $acl)
    {
        if (!$acl->object_id) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_13753452fadd" . "c2d6579d9ba29" . "1d77955"]);
        }
        if (!$acl->class_id) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_5ca1c8340633c331" . "3f886f2a4dccb7e8"]);
        }
        $acl->Clear();
        $_4e6a0dcf937145a7f2e335810c4e2d07 = $this->GetCacheKey($acl);
        $_ed121af062079329173bb510b5a82097 = $this->cache->Get($_4e6a0dcf937145a7f2e335810c4e2d07);
        if ($_ed121af062079329173bb510b5a82097 === null) {
            $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_b794b4b6e96b498c4b" . "34de980e60c7c7"], $acl->object_id, $acl->class_id);
            $_ed121af062079329173bb510b5a82097 = [];
            while ($_b8cfc2e06d9d1fec1893ea4a054002bf = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
                $_ed121af062079329173bb510b5a82097[] = $_b8cfc2e06d9d1fec1893ea4a054002bf;
            }
            $this->cache->Set($_4e6a0dcf937145a7f2e335810c4e2d07, $_ed121af062079329173bb510b5a82097);
        }
        foreach ($_ed121af062079329173bb510b5a82097 as $_b8cfc2e06d9d1fec1893ea4a054002bf) {
            list($_0f0ee93b89a6a83a69ad4a5909c20cb0, $_1681112f53987f6e29f76d473c53a8f4, $perms) = $_b8cfc2e06d9d1fec1893ea4a054002bf;
            $acl->Add($perms, $_0f0ee93b89a6a83a69ad4a5909c20cb0, $_1681112f53987f6e29f76d473c53a8f4);
        }
    }
    protected function GetCacheKey(Acl $acl)
    {
        return $GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_f4ebcb18" . "d6635cf03" . "40b0776aa" . "6c2368"] . $acl->class_id . $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_58d506edba9ce80af6a061b73e2" . "eb66c"] . $acl->object_id;
    }
    
    
    
    
    public function Save(Acl $acl)
    {
        if (!$acl->object_id) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_3f0a984c475ce692d87e01dd" . "abf63065"]);
        }
        if (!$acl->class_id) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_966b46f1eeef931d3aab021091" . "17071b"]);
        }
        if ($acl->object_id) {
            $this->Delete($acl);
        }
        foreach ($acl->GetRights() as $_0f0ee93b89a6a83a69ad4a5909c20cb0 => $_3762efdba5c60ca7475e876f0ddacbd8) {
            foreach ($_3762efdba5c60ca7475e876f0ddacbd8 as $_1681112f53987f6e29f76d473c53a8f4 => $perms) {
                if ($perms) {
                    $this->db->query($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_c75934a16a05f05c144" . "32ff269640ec4"] . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_0d42dc2ab069" . "f31f94b667ad8" . "3e04b04"], $acl->class_id, $acl->object_id, $_0f0ee93b89a6a83a69ad4a5909c20cb0, $_1681112f53987f6e29f76d473c53a8f4, $perms);
                }
            }
        }
        $this->cache->Delete($this->GetCacheKey($acl));
    }
    
    
    
    
    
    
    public function Delete(Acl $acl)
    {
        if (!$acl->object_id) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_c726d95450d9d503c7ef866" . "71a4fc991"]);
        }
        if (!$acl->class_id) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_3b772c19f5d5e7c8d750" . "ae0a815c7ed7"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_f3a6782a0639ec7ac8ea0" . "a44e06d50fa"], $acl->class_id, $acl->object_id);
        $this->cache->Delete($this->GetCacheKey($acl));
    }
    
    
    
    
    
    
    
    
    
    
    public function Permits(SecurityContext $context, $rights, $_f48acc58bf4e08e63b1173fb1800d0f6, $object_id, $_5e0bec805e42a373f593a284d3fbd303 = 0)
    {
        
        
        if (true || $this->IsCached($_f48acc58bf4e08e63b1173fb1800d0f6, $object_id)) {
            $acl = $this->Get($_f48acc58bf4e08e63b1173fb1800d0f6, $object_id);
            return $acl->Permits($context, $rights, $_5e0bec805e42a373f593a284d3fbd303);
        } else {
            
            
            return $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_190a27304b863980e" . "14c5514d55f6770"]($_f48acc58bf4e08e63b1173fb1800d0f6, $object_id, $_5e0bec805e42a373f593a284d3fbd303, $rights);
        }
    }
    private function IsCached($_f48acc58bf4e08e63b1173fb1800d0f6, $object_id)
    {
        return $this->cache->Get($this->GetCacheKey(new Acl($_f48acc58bf4e08e63b1173fb1800d0f6, $object_id))) !== null;
    }
}